// getApp.js - the webservice.  Run using node getApp.

// Require the module
var express = require("express");

// Create the express app
var app = express();

// Could do on one line
//var app= require('express')();

// The login credentials
const expectedAuthString = "Basic " + new Buffer("username:password").toString("base64");

// Define the GET endpoint
app.get("/users", function (req, res) {

	// Log the call
	// console.log("The req parameter contains request info");
	// console.log(req);

    // Parse the auth header - TODO needs separate function and tests
	const auth = req.header("Authorization");
	//console.log('Auth header=' + auth);

	const tmp = auth.split(' ');   // Split on a space, the original auth looks like  "Basic Y2hhcmxlczoxMjM0NQ==" and we need the 2nd part 
    const buf = new Buffer(tmp[1], 'base64'); // create a buffer and tell it the data coming in is base64 
    const plain_auth = buf.toString();        // read it back out as a string 
    console.log("Decoded Authorization ", plain_auth); 
    // At this point plain_auth = "username:password" 
    const creds = plain_auth.split(':');      // split on a ':' 
    const username = creds[0]; 
    const password = creds[1]; 

	// Check authentication
	if (req.header("Authorization") != expectedAuthString) {
		// throw some sort of error
		res.status(401)
			.send('Get lost');  // body

		return;
	}

	// Send a json packet instead of a string.  
	res.status(200)
		.send({ name: 'marcus' })  // body
		;

	// console.log("And the res the response information");
	// console.log(res);
});

// Other endpoints done the same way
app.post("/users", function (req, res) { res.send("all the HTTP verb looks the same");});
app.patch("/users", function (req, res) { res.send("all the HTTP verb looks the same");});
app.del("/users", function (req, res) { res.send("all the HTTP verb looks the same");});
// and HEAD and OPTIONS and what have you... 

// Set Express to listen on port 3000
app.listen(3000);
console.log("you can now post, delete, get, and patch to http://localhost:3000/users");

// In order to reach the app from other modules
// we need to export the express application
module.exports.getApp = app;